;@GOTO TRANSLATE

.MODEL TINY
.586P

Int20 EQU 20H

 INCLUDE ExD.inc

.CODE
.STARTUP
     JMP   Install

;---Do not change!--------------------------------------------------------------
 NEW20:
     PUSH  FS GS ES DS	
     PUSH  CS
     POP   DS
     MOV   PUSHREGS,SP
     PUSHAD		
     MOV   POPREGS,SP

     AND   BYTE PTR [ESP+44], NOT 1 ;CLC

     PUSH  WORD PTR  [ESP+44]
     POP   AX
     MOV   FLMASK,AH

     PUSH  DWORD PTR [ESP+40]
     POP   SI DS
     CLD
     LODSD

     PUSH  CS
     POP   DS

     MOV  _VXDNUMS,EAX
     MOV  _INT20,20CDH

     PUSH  0
     POP   FS
     PUSH  DWORD PTR FS:21H*4
     POP   Old21
     PUSH  CS OFFSET Temp21
     POP   DWORD PTR FS:21H*4

     MOV  _SS,SS
     MOV  _SP,SP


     MOV   AX,1687H
     INT   2FH
     OR    AX,AX
     JNE   DPMIFailed


     PUSH  ES  DI
     POP   GoDPMI

     JCXZ  $+2

     MOV   AX,DS:2
     SUB   AX,SI
     MOV   ES,AX

     SUB   AX,AX
            DB    9AH
     GoDPMI DD    00H
     JC    DPMIFailed

     SUB   AX,AX
     MOV   CX,1
     INT   31H
     MOV   BX,AX

     LEA   DI,BigDesc
     MOV   AX,0CH
     PUSH  DS
     POP   ES
     INT   31H
     MOV   FS,BX

     MOV   AX,6
     MOV   BX,CS
     INT   31H
     PUSH  CX DX
     POP   CODEBASE

     SUB   AX,AX
     MOV   CX,1
     INT   31H
     MOVZX EDI,AX
     MOV   GateSel,AX
     AND   DI,NOT 7
     JMP   $+2

     CLI
     SGDT  GDT
     MOV   ESI,GDTBase
     SLDT  DX
     MOVZX EDX,DX
     ADD   ESI,EDX
     MOV   DH,FS:[ESI+7]
     MOV   DL,FS:[ESI+4]
     PUSH  DX WORD PTR FS:[ESI+2]
     POP   ESI

     MOV   EAX,OFFSET emuVxD
     ADD   EAX,CODEBASE
     MOV   FS:[ESI+EDI],AX
     MOV   WORD PTR FS:[ESI+EDI+2], Rg0FlatCodeSelector
     MOV   AX,0EC00H
     MOV   FS:[ESI+EDI+4],EAX

     MOV   S_SP,SP

     MOV   SP,POPREGS
     POPAD

     MOV   SP,S_SP

	   DB 066H
	   DB 09AH
	   DD 000H
   GateSel DW 000H

     MOV   S_SP,SP

     MOVZX ESP,PUSHREGS
     PUSHF
     POP   WORD PTR [ESP+8+4]
     PUSHAD

     MOV   SP,S_SP

     STI

     MOV   AX,1
     MOV   BX,GateSel
     INT   31H

     MOV   AX,1
     MOV   BX,FS
     INT   31H

     .EXIT

   Temp21:
     PUSHF
     CMP   AH,4CH
     JE    IsExit
     POPF
     DB    0EAH
     Old21 DD ?
    IsExit:
     LSS   SP, CS:MyStack
     JMP   Obolos

    DPMIFailed:
     OR    BYTE PTR [ESP+44],1 ;SETC

    Obolos:
     MOV   AL,FLMASK
     OR    [ESP+45],AL
     POPAD	   
     POP   DS ES GS
     PUSH  0
     POP   FS
     PUSH  CS:Old21
     POP   DWORD PTR FS:21H*4
     POP   FS	   
     ADD   WORD PTR [ESP],4
     IRET

  emuVxD:
     PUSH  DS ES AX
     DB    66H
     MOV   AX,Rg0FlatDataSelector
     MOV   DS,AX
     MOV   ES,AX
     POP   AX
    _INT20 LABEL WORD
     INT   20H
    _VXDNUMS DD ?
     POP   ES DS
     RETF


  Install:
     MOV   AX,1600H
     INT   2FH
     CMP   AL,3
     LEA   DX,NoWin
     JL    Write

     PUSH  0
     POP   FS
     PUSH  DWORD PTR FS:4*Int20
     POP   Old20
     PUSH  CS OFFSET NEW20
     POP   DWORD PTR FS:4*Int20

;Here place your code-----------------------------------------------------------

     MOV   AH,9
     LEA   DX,IntroMessage
     INT   21H

     VxDCall  VSD_Bell
     JNC   VxDSuccess    ;CF is SET according to VCALL or if DPMI failed
                         ;so check if after every VCALL

    VxDFailed:
     LEA   DX,NoVxD
     JMP   Write

  VxDSuccess:
     LEA   DX,VxDOK
  Write:
     MOV   AH,9
     INT   21H

     PUSH  Old20
     POP   DWORD PTR FS:4*Int20
    .EXIT

.DATA
  IntroMessage DB 13,10,"Template by Templary"
               DB 13,10,"Template beeeeps!",36

  NoWin	       DB 13,10,"Windows required!",7,36
  NoVxD	       DB 13,10,"Something failed!",7,36
  VxDOK	       DB 13,10,"All right!",36


    BigDesc    DQ 008FF2000000FFFFH
    MyStack    LABEL DWORD
	_SP    DW ?
	_SS    DW ?

    S_SP       DW ?

    Old20      DD ?
    PUSHREGS   DW ?
    POPREGS    DW ?
    CODEBASE   DD ?
    FLMASK     DB ?

   GDT	       LABEL FWORD
    GDTSize    DW ?
    GDTBase    DD ?

END

:TRANSLATE
@ECHO OFF
TASM /M /T /Q /I..\Include\ Template.BAT
TLINK /3/t/x Template
DEL	     Template.obj


